---
title: Get Keys
description: The GET {{apiPath}}/v1/environments/{{envID}}/keys endpoint returns a list of all key resources for the specified environment.
component: pingone-api
page_id: pingone-api:platform:certificate-management/get-keys
canonical_url: https://developer.pingidentity.com/pingone-api/platform/certificate-management/get-keys.html
section_ids:
  headers: Headers
  example-request: Example Request
  example-response: Example Response
---

# Get Keys

##

```none
GET {{apiPath}}/v1/environments/{{envID}}/keys
```

The `GET {{apiPath}}/v1/environments/{{envID}}/keys` endpoint returns a list of all key resources for the specified environment.

The sample returns the complete list of key resources associated with the environment ID specified in the request URL.

This operation allows SCIM filtering on the `algorithm` and `status` properties with the `eq` operator. The following sample returns the list of valid key resources associated with the environment ID specified in the request URL:

```none
https://api.pingone.com/v1/environments/{{envID}}/keys?filter=status eq "VALID"
```

> **Collapse: Query parameters**
>
> | Parameter | Description                         |
> | --------- | ----------------------------------- |
> | `filter`  | `algorithm` (`eq`), `status` (`eq`) |

### Headers

Authorization      Bearer {{accessToken}}

##

### Example Request

* cURL

* C#

* Go

* HTTP

* Java

* jQuery

* NodeJS

* Python

* PHP

* Ruby

* Swift

```shell
curl --location --globoff '{{apiPath}}/v1/environments/{{envID}}/keys' \
--header 'Authorization: Bearer {{accessToken}}'
```

```csharp
var options = new RestClientOptions("{{apiPath}}/v1/environments/{{envID}}/keys")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Get);
request.AddHeader("Authorization", "Bearer {{accessToken}}");
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

```golang
package main

import (
  "fmt"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/v1/environments/{{envID}}/keys"
  method := "GET"

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, nil)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

```http
GET /v1/environments/{{envID}}/keys HTTP/1.1
Host: {{apiPath}}
Authorization: Bearer {{accessToken}}
```

```java
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("text/plain");
RequestBody body = RequestBody.create(mediaType, "");
Request request = new Request.Builder()
  .url("{{apiPath}}/v1/environments/{{envID}}/keys")
  .method("GET", body)
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
```

```javascript
var settings = {
  "url": "{{apiPath}}/v1/environments/{{envID}}/keys",
  "method": "GET",
  "timeout": 0,
  "headers": {
    "Authorization": "Bearer {{accessToken}}"
  },
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
```

```javascript
var request = require('request');
var options = {
  'method': 'GET',
  'url': '{{apiPath}}/v1/environments/{{envID}}/keys',
  'headers': {
    'Authorization': 'Bearer {{accessToken}}'
  }
};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

```python
import requests

url = "{{apiPath}}/v1/environments/{{envID}}/keys"

payload = {}
headers = {
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("GET", url, headers=headers, data=payload)

print(response.text)
```

```php
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/v1/environments/{{envID}}/keys');
$request->setMethod(HTTP_Request2::METHOD_GET);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Authorization' => 'Bearer {{accessToken}}'
));
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
```

```ruby
require "uri"
require "net/http"

url = URI("{{apiPath}}/v1/environments/{{envID}}/keys")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Get.new(url)
request["Authorization"] = "Bearer {{accessToken}}"

response = http.request(request)
puts response.read_body
```

```swift
var request = URLRequest(url: URL(string: "{{apiPath}}/v1/environments/{{envID}}/keys")!,timeoutInterval: Double.infinity)
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "GET"

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()
```

### Example Response

200 OK

```json
{
    "_links": {
        "self": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/keys"
        }
    },
    "_embedded": {
        "keys": [
            {
                "_links": {
                    "self": {
                        "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/keys/11b40ce3-fb02-4ee7-b5df-3abe64c6dda3"
                    }
                },
                "id": "11b40ce3-fb02-4ee7-b5df-3abe64c6dda3",
                "name": "Default",
                "serialNumber": 1558460844151,
                "issuerDN": "CN=Default-trial_ping_identity_981041295",
                "subjectDN": "CN=Default-Default, OU=Ping Identity, O=Ping Identity, C=US",
                "algorithm": "RSA",
                "keyLength": 2048,
                "createdAt": "2019-05-21T17:47:24.151Z",
                "startsAt": "2019-05-21T17:47:24.151Z",
                "expiresAt": "2020-05-20T17:47:24.151Z",
                "validityPeriod": 365,
                "signatureAlgorithm": "SHA256withRSA",
                "usageType": "ENCRYPTION",
                "status": "VALID",
                "organization": {
                    "id": "bed432e6-676a-4ebe-b5a5-6b3b54e46bda"
                },
                "environment": {
                    "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
                },
                "default": true
            },
            {
                "_links": {
                    "self": {
                        "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/keys/5183c34a-6e64-4e19-9e83-69c0de54e744"
                    }
                },
                "id": "5183c34a-6e64-4e19-9e83-69c0de54e744",
                "name": "Default",
                "serialNumber": 1558460843791,
                "issuerDN": "CN=Default-trial_ping_identity_981041295",
                "subjectDN": "CN=Default-Default, OU=Ping Identity, O=Ping Identity, C=US",
                "algorithm": "RSA",
                "keyLength": 2048,
                "createdAt": "2019-05-21T17:47:23.791Z",
                "startsAt": "2019-05-21T17:47:23.791Z",
                "expiresAt": "2020-05-20T17:47:23.791Z",
                "validityPeriod": 365,
                "signatureAlgorithm": "SHA256withRSA",
                "usageType": "SIGNING",
                "status": "VALID",
                "organization": {
                    "id": "bed432e6-676a-4ebe-b5a5-6b3b54e46bda"
                },
                "environment": {
                    "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
                },
                "default": true
            }
        ]
    },
    "size": 2
}
```
